<%
'------------------------------------------------------------
'
'   Epson Internet Printing Project
'
'   Copyright (c) Seiko Epson Corporation 1999
'
'------------------------------------------------------------
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetStatus()
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    On Error Resume Next

	Const L_WrongIP_Message = "The IP Address is not correct."
	Const L_PageTitle_Text = "Microsoft Default SNMP status"
	Const strFileID = "page1.asp"

    Dim strIP
    Dim objSNMP
    Dim strSt, strCommunity, iDevice
    Dim strPrinter

    Err.Clear
	GetStatus = ""

    strIP = Request(IPADDRESS)
    If strIP = "" Then
		GetStatus = ""
		Err.Number = 1
		Err.Description = L_WrongIP_Message
		ErrorHandler (strFileID)
		Exit Function
    End If

    strCommunity    = Request (COMMUNITY)
    iDevice         = Request(DEVICE)
    strPrinter      = Request(PRINTER)

    Set objSNMP = Server.CreateObject(PROGID_SNMP)
    If Err.Number <> 0 Then
		GetStatus = ""
		ErrorHandler (strFileID)
		Exit Function
	End If

    objSNMP.open strIP, strCommunity, 3, 2000

    If Err.Number <> 0 Then
		GetStatus = ""
		ErrorHandler (strFileID)
		Exit Function
	End If

    strSt = objSNMP.Get (".1.3.6.1.4.1.1248.1.2.2.1.1.1.4." & CStr (iDevice))
    If Err.Number <> 0 Then
		GetStatus = ""
		Exit Function
    End If

	GetStatus = strSt

End Function


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetFileDt( fileName, tgtStr )
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	Dim	fsObj
	Dim	txtStreamObj
	Dim	strDt
	Dim	strWk
	Dim	i,j

	GetFileDt = ""

	On Error Resume Next
	Err.Clear

	Set fsObj = Server.CreateObject("Scripting.FileSystemObject")
	Set txtStreamObj = fsObj.OpenTextFile(Server.MapPath(fileName),1,False,False)

    If Err.Number <> 0 Then
		ErrorHandler (strFileID)
		Exit Function
	End If

	Do
		strDt = txtStreamObj.ReadLine
		if InStr(strDt, tgtStr) > 0 then
			i = InStr(InStr(strDt, tgtStr), strDt, "=" )
			j = Len(strDt) - i
			strWk = Mid(strDt,i+1,j)
			GetFileDt = Mid(Trim(strWk), 2, Len(strWk)-3)
			Exit Do
		End If
		if strDt = "0" then
			Exit Do
		End if
	Loop While txtStreamObj.AtEndOfLine = False

	txtStreamObj.Close

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	PutGauge( volume, heightPx, color1, color2 )
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	
	Dim vol1
	Dim vol2
	Dim strHtml

	On Error Resume Next
	Err.Clear

	vol1 = volume
	vol2 = 100 - vol1

	if vol1 = -1 then
            strHtml = ""
	elseif vol1 = 0 then
            strHtml = "<td width="""
            strHtml = strHtml & vol2
            strHtml = strHtml & "%"" bgcolor=""" & color2 & """ height="""
            strHtml = strHtml & heightPx
            strHtml = strHtml & "px""></td>"

	elseif vol2 = 0 then
            strHtml = "<td width="""
            strHtml = strHtml & vol1
            strHtml = strHtml & "%"" bgcolor=""" & color1 & """ height="""
            strHtml = strHtml & heightPx
            strHtml = strHtml & "px""></td>"

	else
            strHtml = "<td width="""
            strHtml = strHtml & vol1
            strHtml = strHtml & "%"" bgcolor=""" & color1 & """ height="""
            strHtml = strHtml & heightPx
            strHtml = strHtml & "px""></td>"
            strHtml = strHtml & "<td width="""
            strHtml = strHtml & vol2
            strHtml = strHtml & "%"" bgcolor=""" & color2 & """ height="""
            strHtml = strHtml & heightPx
            strHtml = strHtml & "px""></td>"
	end if

	PutGauge = strHtml

End Function


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetNetwork(netWork, rgConText)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	On Error Resume Next
	Err.Clear

	Const L_WrongIP_Message = "The IP Address is not correct."
	Const strFileID = "page1.asp"

    Dim strIP
    Dim objSNMP
    Dim strSt, strCommunity, iDevice
    Dim strPrinter
    Dim bRet

    Err.Clear
	GetNetwork = False

    strIP = Request(IPADDRESS)
    If strIP = "" Then
		GetStatus = ""
		Err.Number = 1
		Err.Description = L_WrongIP_Message
		ErrorHandler (strFileID)
		Exit Function
    End If

    strCommunity    = Request (COMMUNITY)
    iDevice         = Request(DEVICE)
    strPrinter      = Request(PRINTER)

    Set objSNMP = Server.CreateObject(PROGID_SNMP)
    If Err.Number <> 0 Then
		Exit Function
	End If

    objSNMP.open strIP, strCommunity, 3, 2000
    If Err.Number <> 0 Then
		Exit Function
	End If

	select case netWork
		case 1
			bRet = GetEthernet(objSNMP, iDevice, rgConText)
		case 2
			bRet = GetTcp(objSNMP, iDevice, rgConText)
		case 3
			bRet = GetNetware(objSNMP, iDevice, rgConText)
		case 4
			bRet = GetApple(objSNMP, iDevice, rgConText)
		case 5
			bRet = GetNetbeui(objSNMP, iDevice, rgConText)
		case 6
			bRet = GetSnmp(objSNMP, iDevice, rgConText)
	end select

    If bRet = False Then
		Exit Function
	End If

	GetNetwork = True

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetEthernet(objSNMP, iDevice, rgConText)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const NIC_NAME			= ".1.3.6.1.2.1.2.2.1.2."
Const NIC_HARWARE_VER	= ".1.3.6.1.4.1.1248.1.1.3.1.1.3.0"
Const NIC_FIRMWARE_VER	= ".1.3.6.1.4.1.1248.1.1.3.1.1.4.0"
Const NIC_INTERFACE		= ".1.3.6.1.4.1.1248.1.1.3.1.1.9.0"

	On Error Resume Next
	Err.Clear

    Dim rgOidList
    Dim rgConsole

    GetEthernet = False

    rgOidList = Array(NIC_NAME & iDevice, _
					  NIC_HARWARE_VER, _
					  NIC_FIRMWARE_VER, _
					  NIC_INTERFACE)

    rgConText = objSNMP.GetList(rgOidList)
    If Err.Number <> 0 Then
		Exit Function
	End if

	if 0 < InStr(rgConText(0), " ") then
		rgConText(0) = Left(rgConText(0), InStr(rgConText(0), " "))
	End if

    GetEthernet = True

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetTcp(objSNMP,iDevice, rgConText)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const ENABLE_TCPIP		= ".1.3.6.1.4.1.1248.1.1.3.1.1.20.0"
Const IP_ADRESS_AUTO	= ".1.3.6.1.4.1.1248.1.1.3.1.1.21.0"
Const IP_ADRESS			= ".1.3.6.1.4.1.1248.1.1.3.1.1.22.0"

	On Error Resume Next
	Err.Clear

    Dim StrDev
    Dim rgOidList
    Dim rgConsole
    Dim i

    StrDev = CStr(iDevice)
    GetTcp = False

    rgOidList = Array(ENABLE_TCPIP, _
					  IP_ADRESS_AUTO, _
					  IP_ADRESS)

    rgConText = objSNMP.GetList(rgOidList)
    If Err.Number <> 0 Then
		Exit Function
	End if

    GetTcp = True

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetNetware(objSNMP,iDevice, rgConText)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const ENABLE_NETWARE	= ".1.3.6.1.4.1.1248.1.1.3.1.1.12.0"
Const FRAME_TYPE		= ".1.3.6.1.4.1.1248.1.1.3.1.1.13.0"
Const NETWARE_MODE		= ".1.3.6.1.4.1.1248.1.1.3.1.4.3.0"
Const PRI_FILE_SERVER	= ".1.3.6.1.4.1.1248.1.1.3.1.4.5.0"
Const PRINT_SERVER		= ".1.3.6.1.4.1.1248.1.1.3.1.4.4.0"
Const POLLING_INTERVAL	= ".1.3.6.1.4.1.1248.1.1.3.1.4.7.0"
Const PRI_PRINT_SERVER	= ".1.3.6.1.4.1.1248.1.1.3.1.4.8.0"
Const PORT_NUMBER		= ".1.3.6.1.4.1.1248.1.1.3.1.4.9.0"
Const NDS_TREE_NAME		= ".1.3.6.1.4.1.1248.1.1.3.1.1.17.0"

	On Error Resume Next
	Err.Clear

    Dim StrDev
    Dim rgOidList
    Dim rgConsole
    Dim i

    StrDev = CStr(iDevice)
    GetNetware = False

    rgOidList = Array(ENABLE_NETWARE, _
					  FRAME_TYPE, _
					  NETWARE_MODE, _
					  PRI_FILE_SERVER, _
					  PRINT_SERVER, _
					  POLLING_INTERVAL, _
					  PRI_PRINT_SERVER, _
					  PORT_NUMBER, _
					  NDS_TREE_NAME)

    rgConText = objSNMP.GetList(rgOidList)
    If Err.Number <> 0 Then
		Exit Function
	End if

    GetNetware = True

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetApple(objSNMP,iDevice, rgConText)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const ENABLE_APPLE_TALK		= ".1.3.6.1.4.1.1248.1.1.3.1.1.25.0"
Const NETWORK_NUMBER_SET	= ".1.3.6.1.4.1.1248.1.1.3.1.1.28.0"
Const NETWORK_NUMBER		= ".1.3.6.1.4.1.1248.1.1.3.1.1.29.0"
Const ZONE_NAME				= ".1.3.6.1.4.1.1248.1.1.3.1.1.27.0"
Const PRINTER_NAME			= ".1.3.6.1.4.1.1248.1.1.3.1.4.10.0"
Const PRINTER_ENTRY_TYPE	= ".1.3.6.1.4.1.1248.1.1.3.1.4.17.1.2"

	On Error Resume Next
	Err.Clear

    Dim StrDev
    Dim rgOidList
    Dim rgConsole
    Dim i,j,k

    StrDev = CStr(iDevice)
    GetApple = False

    rgOidList = Array(ENABLE_APPLE_TALK, _
					  NETWORK_NUMBER_SET, _
					  NETWORK_NUMBER, _
					  ZONE_NAME, _
					  PRINTER_NAME)

    rgConText = objSNMP.GetList(rgOidList)
    If Err.Number <> 0 Then
		Exit Function
	End if

    rgConsole = objSNMP.GetTree(PRINTER_ENTRY_TYPE)

	i = Ubound(rgConText)
	j = Ubound(rgConsole,2)

	if j >= 0 then
		ReDim Preserve rgConText(i+j+1)

		for k = 0 to j
			rgConText(i+k+1) = rgConsole(1,k)
		Next
	End if

    GetApple = True

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetNetbeui(objSNMP,iDevice, rgConText)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const ENABLE_NETBEUI	= ".1.3.6.1.4.1.1248.1.1.3.1.1.30.0"
Const DOMAIN_NAME		= ".1.3.6.1.4.1.1248.1.1.3.1.1.32.0"
Const NODE_NAME			= ".1.3.6.1.4.1.1248.1.1.3.1.1.33.0"
Const DEVICE_NAME		= ".1.3.6.1.4.1.1248.1.1.3.1.4.16.0"

	On Error Resume Next
	Err.Clear

    Dim StrDev
    Dim rgOidList
    Dim rgConsole
    Dim i

    StrDev = CStr(iDevice)
    GetNetbeui = False

    rgOidList = Array(ENABLE_NETBEUI, _
					  DOMAIN_NAME, _
					  NODE_NAME, _
					  DEVICE_NAME)

    rgConText = objSNMP.GetList(rgOidList)
    If Err.Number <> 0 Then
		Exit Function
	End if

    GetNetbeui = True

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetSnmp(objSNMP,iDevice, rgConText)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const COMMUNITY_NAME		= ".1.3.6.1.4.1.1248.1.1.3.1.2.1.0"
Const TRAP1_IP_ENABLE		= ".1.3.6.1.4.1.1248.1.1.3.1.2.9.0"
Const TRAP1_COMMUNITY_NAME	= ".1.3.6.1.4.1.1248.1.1.3.1.2.5.0"
Const TRAP2_IP_ENABLE		= ".1.3.6.1.4.1.1248.1.1.3.1.2.10.0"
Const TRAP2_COMMUNITY_NAME	= ".1.3.6.1.4.1.1248.1.1.3.1.2.6.0"
Const TRAP_IPX_NAME_TB		= ".1.3.6.1.4.1.1248.1.1.3.1.2.15.1.2"
Const TRAP_IPX_ENABLE_TB	= ".1.3.6.1.4.1.1248.1.1.3.1.2.15.1.3"

	On Error Resume Next
	Err.Clear

    Dim StrDev
    Dim rgOidList
    Dim rgConsole
    Dim rgConsole2
    Dim iNameCnt
    Dim iEnableCnt
    Dim iCnt
    Dim i,j,k

    StrDev = CStr(iDevice)
    GetSnmp = False

    rgOidList = Array(COMMUNITY_NAME, _
					  TRAP1_IP_ENABLE, _
					  TRAP1_COMMUNITY_NAME, _
					  TRAP2_IP_ENABLE, _
					  TRAP2_COMMUNITY_NAME)

    rgConText = objSNMP.GetList(rgOidList)
    If Err.Number <> 0 Then
		Exit Function
	End if

    rgConsole = objSNMP.GetTree(TRAP_IPX_ENABLE_TB)
    rgConsole2 = objSNMP.GetTree(TRAP_IPX_NAME_TB)

	iCnt = Ubound(rgConText)

	if IsArray(rgConsole) then
		iEnableCnt = Ubound(rgConsole,2) + 1
	else
		iEnableCnt = 0
	End if

	if IsArray(rgConsole2) then
		iNameCnt = Ubound(rgConsole2,2) + 1
	else
		iNameCnt = 0
	End if

	if iEnableCnt + iNameCnt >= 0 then
		ReDim Preserve rgConText(iCnt + iEnableCnt + iNameCnt)

		j = 0
		k = 0
		for i = iCnt + 1 to UBound(rgConText)
			if iNameCnt > j then
				rgConText(i) = rgConsole(1,j)
			else
				rgConText(i) = ""
			End if
			i = i + 1
			if iEnableCnt > k then
				rgConText(i) = rgConsole2(1,k)
			else
				rgConText(i) = ""
			End if
			j = j + 1
			k = k + 1
		Next
	End if
    GetSnmp = True

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	GetDriver()
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

    Dim strIP
    Dim objSNMP
    Dim strSt, strCommunity, iDevice
    Dim strPrinter

	On Error Resume Next
	Err.Clear

	GetDriver = ""

    strIP = Request(IPADDRESS)
    If strIP = "" Then
		GetStatus = ""
		Err.Number = 1
		Err.Description = L_WrongIP_Message
		ErrorHandler (strFileID)
		Exit Function
    End If

    strCommunity    = Request (COMMUNITY)
    iDevice         = Request(DEVICE)
    strPrinter      = Request(PRINTER)

    Set objSNMP = Server.CreateObject(PROGID_SNMP)
    If Err.Number <> 0 Then
		Exit Function
	End If

    objSNMP.open strIP, strCommunity, 3, 2000
    If Err.Number <> 0 Then
		Exit Function
	End If

    strSt = objSNMP.Get (".1.3.6.1.2.1.25.3.2.1.3." & CStr (iDevice))
    If Err.Number <> 0 Then
		Exit Function
    End If

	GetDriver = strSt

End Function


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function	ChkDrv( strDrvNM )
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	On Error Resume Next
	Err.Clear

	if InStr( OleCvt.DecodeUnicodeName(Request(MODEL)), strDrvNM ) > 0 then
		ChkDrv = ""
	else
		ChkDrv = "DRIVER01"
	End if

End Function
%>